package ftps_protocol_crawler_go

import (
	"loafle.com/overflow/crawler_go"
	"testing"
	"loafle.com/overflow/of_rpc_go/models/param"
	"encoding/json"
	"github.com/stretchr/testify/assert"
	"loafle.com/overflow/of_rpc_go"
	"log"
	"time"
	"loafle.com/overflow/of_rpc_go/client"
)

func setConfig() crawler.Crawler {
	r := NewFTPSHealthCrawler()
	m := make(map[string]interface{}, 0)

	m["ip"] = "192.168.1.103"
	m["port"] = "2121"
	m["portType"] = "tcp"
	m["ssl"] = false

	r.PutConfig("ftps", m)

	return r
}

func TestMatch(t *testing.T) {
	r := setConfig()

	out := param.Output{}
	r.Get("ftps", &out)

	var check bool
	json.Unmarshal(out.Data, &check)

	assert.Equal(t, true, check)
}


func start() {
	r := setConfig()

	of_rpc.AddDelegate("ftps", r)
	err := of_rpc.StartJSONRPC()
	if err != nil {
		log.Fatal(err)
	}
}

func TestRPC(t *testing.T) {
	go start()
	time.Sleep(2 * time.Second)

	in := param.Input{
		Name: "ftps",
		Id:   "ftps",
	}

	result, err := client.InvokeJSONRPCGet("50000", in)

	if err != nil {
		t.Fatal(err)
	}

	var check bool
	json.Unmarshal(result.Data, &check)
	assert.Equal(t, true, check)
}

//
//func TestRPC(t *testing.T) {
//
//	go start()
//	time.Sleep(time.Second * 2)
//
//	p := protocol.HealthRequest{IsSSL: false}
//	b, _ := json.Marshal(p)
//
//	in := param.Input{Ip: "192.168.1.215", Port: 21, Data: b}
//
//	re, _ := client.InvokeJSONRPC("50000", in)
//	var m protocol.HealthResponse
//	json.Unmarshal(re.Data, &m)
//
//	assert.Equal(t, false, m.IsMatch)
//}
