package wmi_protocol_crawler_go

import (
	"encoding/json"
	"loafle.com/overflow/commons_go/matcher/wmi"
	"loafle.com/overflow/crawler_go"
)

type WMIHeahthCrawler struct {
	crawler.SocketHeahthCrawler
}

func (r *WMIHeahthCrawler)Internal(params map[string]interface{}) ([]byte, error) {
	
	b, err := r.CheckHeahth(params)
	if err != nil {
		// set error
	}
	return json.Marshal(b)
}

func NewWMIHeahthCrawler() *WMIHeahthCrawler {
	r := &WMIHeahthCrawler{}
	r.SetInternal(r)
	r.SetMatcher(wmi.NewWMIMatcher())
	return r
}


//package wmi_protocol_crawler
//
//import (
//	"loafle.com/overflow/of_rpc/models/param"
//	"encoding/json"
//	"loafle.com/overflow/of_rpc/models/protocol"
//	"strconv"
//	"crypto/tls"
//	"net"
//
//	"loafle.com/overflow/collector/core/scan/service/matcher/wmi"
//	"loafle.com/overflow/collector/core/scan/service/matcher/packet"
//	rpc "loafle.com/overflow/of_rpc/json"
//
//	"log"
//)
//
//////////////// Delegate.Get implement /////////////////
//type WMIProtocol struct{}
//
//func (r *WMIProtocol) Get(input *param.Input, output *param.Output) error {
//
//	rr := &protocol.HealthRequest{}
//	json.Unmarshal(input.Data, &rr)
//
//	rres, err := check(input.Ip, input.Port, rr.IsSSL)
//
//	if err != nil {
//		return err
//	}
//
//
//	retVal := &protocol.HealthResponse{}
//	retVal.IsMatch = rres
//
//	b, err := json.Marshal(retVal)
//
//	if err != nil {
//		return err
//	}
//
//	*output = param.Output{Data: b}
//	return nil
//}
//
//
//func connect(ip string, port uint16, ssl bool) (net.Conn, error) {
//
//	var addr string = ip
//	addr += ":"
//	addr += strconv.Itoa(int(port))
//
//	if ssl == false {
//		conn, err := net.Dial("tcp", addr)
//		if err != nil {
//			return nil, err
//		}
//		return conn, nil
//	} else {
//		conn, err := tls.Dial(
//			"tcp",
//			addr,
//			&tls.Config{
//				InsecureSkipVerify: true,
//				ServerName:         ip,
//			},
//		)
//		if err != nil {
//			return nil, err
//		}
//		return conn, nil
//	}
//}
//
//
//
//func check(ip string, port uint16, ssl bool) (bool, error) {
//
//	conn, err := connect(ip, port, ssl)
//	if err != nil {
//		return false, err
//	}
//	defer conn.Close()
//
//	m := wmi.NewWMIMatcher()
//
//	for i := 0; i < m.PacketCount(); i++ {
//
//		pack := m.Packet(i)
//		conn.Write(pack.Buffer)
//		bytes := make([]byte, 1024)
//		n, _ := conn.Read(bytes)
//		p := packet.NewPacket(bytes, n)
//
//		if m.IsNoResponse(i) == true { // empty last response
//			break
//		}
//
//		if m.Match(i, p, nil) == false {
//			return false, nil
//		}
//	}
//
//	return true, nil
//}
//
//func start() {
//
//	rpc.SetDelegate(new(WMIProtocol))
//	err := rpc.StartJSONRPC()
//	if err != nil {
//		log.Fatal(err)
//	}
//}
//
//func main() {
//	start()
//}
